// ClientDlg.h : header file
//

#if !defined(AFX_CLIENTDLG_H__62B8F600_D70D_11D6_8B1E_00065B874763__INCLUDED_)
#define AFX_CLIENTDLG_H__62B8F600_D70D_11D6_8B1E_00065B874763__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CClientDlg dialog

#include "..\SocketInterface.h"

class CClientDlg : public CDialog {
// Construction
public:
  CClientDlg(CWnd* pParent = NULL); // standard constructor

  class CChatClient : public CSocketClient {
    CClientDlg* Dlg;
    void OnReceive() {Dlg->Say(GetReply());}
    void OnClose  () {Dlg->Disconnect();}
    CString GetReply() {
      CString S;
      ArI->ReadString(S); // It'll wait here for as long as the connection is OK. If the connection is broken it returns an empty string.
      return S;
    }
  public:
    void Send(CString Msg) {ArO->WriteString(Msg+"\r\n"); ArO->Flush();}
    CString Connect(CString RemoteIP, BYTE Port, CClientDlg* _Dlg) {Dlg=_Dlg; return CSocketClient::Connect(RemoteIP,Port);}
  } Chat;

  void Say(CString Msg) {if(::IsWindow(m_hWnd)) ((CListBox*)GetDlgItem(IDC_LIST1))->AddString(Msg);}
  void Disconnect() {
    Say("Disconnected");
    GetDlgItem(IDC_Send)->EnableWindow(FALSE);
  }
  // Dialog Data
  //{{AFX_DATA(CClientDlg)
  enum { IDD = IDD_CLIENT_DIALOG };
    // NOTE: the ClassWizard will add data members here
  //}}AFX_DATA

  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CClientDlg)
  //}}AFX_VIRTUAL

// Implementation
protected:

  // Generated message map functions
  //{{AFX_MSG(CClientDlg)
  virtual BOOL OnInitDialog();
  afx_msg void OnSend();
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLIENTDLG_H__62B8F600_D70D_11D6_8B1E_00065B874763__INCLUDED_)
